README file for Commerce Pay

CONTENTS OF THIS FILE
---------------------
* Introduction
* Requirements
* Installation
* Configuration
* How it works
* Troubleshooting
* Maintainers

INTRODUCTION
------------
This project integrates USAePay payment services into the Drupal Commerce
payment and checkout systems.
http://help.usaepay.com/
* For a full description of the module, visit the project page:
  https://www.drupal.org/project/commerce_pay
* To submit bug reports and feature suggestions, or to track changes:
  https://drupal.org/project/issues/commerce_pay


REQUIREMENTS
------------
This module requires the following:
* Libraries API module (https://www.drupal.org/project/libraries);
* Submodules of Drupal Commerce package (https://drupal.org/project/commerce)
  - Commerce core,
  - Commerce Payment (and its dependencies);
* USAePay PHP Library (https://github.com/usaepay/usaepay-php);
* USAePay Merchant account (Console) (https://usaepay.info/merchants).


INSTALLATION
------------
* Install as you would normally install a contributed drupal module.
  See: Installing modules (Drupal 7) documentation page for further information.
  https://drupal.org/documentation/install/modules-themes/modules-7
* Download the USAePay PHP Library from https://github.com/usaepay/usaepay-php
  Drush command:
  drush make --no-core sites/all/modules/commerce_pay/commerce_pay.make
  Make sure you have cURL in your PHP, it is required by USAePay PHP Library.


CONFIGURATION
-------------
* Configure user permissions in Administration > People > Permissions:
  There are no specific permissions for configuration, the Payments
  permissions are to be used for Commerce Pay payments configurations.
   - Access the Commerce Pay debug log
     Users in roles with the "Access the Commerce Pay debug log" permission
     will be able the see the debug messages if they are enabled.
* Enable the default "Payment via Commerce Pay" method or create
  a new one of this type.
* Configure "Payment via Commerce Pay" payment
  Edit "Enable payment method: Payment via Commerce Pay" action (settings).
  - Display title: Title of the payment method when displayed in the payment
    selection. Leave empty to use the default;
  - Source Key: Source Key generated by the Merchant Console at www.usaepay.com;
  - Pin for Source Key: This field is required only if the merchant has set
    a Pin in the merchant console;
  - Use Sandbox server?: If set to true will use the sandbox server.
    Overrides the gateway url parameter;
  - Transaction type:
    Available options:
    Capture, Pre-authorize only (later capturing);
  - Customer billing profile (reference field):
    Select a customer profile reference field attached to your order that
    contains the customer's billing address.
  - Customer shipping profile (reference field):
    Select a customer profile reference field attached to your order that
    contains the customer's shipping address.
  - Send line item data?
    If set to true the order line items data will be sent for the transaction.
  - Enable Card on File functionality with this payment method:
    Save card data on file.
    This settings only available if Commerce Card on File module is enabled.
  - Debugging: Settings about debugging data,
    either to be displayed as page messages or to be logged in system log,
    requires some permissions (see permissions configuration).


HOW IT WORKS
------------

* General considerations:
  - Shop owner must have a USAePay Merchant account (Console)
    https://usaepay.info/merchants
    http://help.usaepay.com/merchant/Support
  - Customer should have valid credit card.

* Customer/Checkout workflow:
  This is an On-Site payment method.
  - Credit card form available for "Commerce Pay" method selected
    in the payment checkout pane;
  - "Card on file" saving options if Commerce Card on File module is enabled.
    Available options:
    "Store this credit card on file for future use.",
    "Set as your default card".

* Back-end workflow:
  - "Capture" transaction type: It will charge (debit) the customers credit card.
  - "Pre-authorize only" transaction type: It runs a credit card authorization.
    If approved, the funds will be held in the customers account.
    It requires later capturing of the payment transaction
  - "Card on file" extra payment option: it will issue a token for future use,
    which will be used with "Card on File" integration.

* Store Admin workflow:
  Payment Terminal (Order admin tab)
  - Add payment: Commerce Pay payment available, credit card form.
  - Capture: for "Pre-authorize only" payments, capture amount editable.
  - Cancel: for "Pre-authorize only" payments that were not captured.
  - Refund: for the captured payments, partial (multiple) refunds available.


TROUBLESHOOTING
---------------
* No troubleshooting pending for now.


MAINTAINERS
-----------
Current maintainers:
* Tavi Toporjinschi (vasike) - https://www.drupal.org/u/vasike

This project has been developed by:
* Commerce Guys
  Commerce Guys are the creators of and experts in Drupal Commerce,
  the eCommerce solution that capitalizes on the virtues and power of Drupal,
  the premier open-source content management system.
  We focus our knowledge and expertise on providing online merchants with
  the powerful, responsive, innovative eCommerce solutions they need to thrive.
  Visit https://commerceguys.com for more information.